"""
    Declare player element class.
"""
import zLOG
from AbstractElement import AbstractElement
from AccessControl import ClassSecurityInfo
from Article import Article
import Globals, interfaces

from Products.CMFCore import CMFCorePermissions
import ArticlePermissions

class PlayerElement(AbstractElement):
    """
    A streaming media player element.
    """
    __implements__ = (interfaces.Element,)

    meta_type = 'Player Element'
    security = ClassSecurityInfo()

    _editableAttributes = ('playerpath',)
    _editableExtraAttributes = ('clear',)
    clear = 'both'
    playerpath = ''

    def __init__(self, id):
        self.id = id

    security.declareProtected(ArticlePermissions.ChangeArticles, 'getEditForm')
    def getEditForm(self):
        " Return the skinned name of the edit form "
        return 'aplayer_edit'

    security.declareProtected(CMFCorePermissions.View, 'getView')
    def getView(self):
        " Return the skinned name of the edit form "
        return 'agoto_player'

    security.declareProtected(ArticlePermissions.ChangeArticles, 'edit')
    def edit(self, playerpath):
        """ Update the value """
        self.playerpath = str(playerpath)

    def SearchableText(self):
        """
            SearchableText is used for full text searches of a portal.
            It should return a concatanation of all useful text.
        """
        return self.Description()

    def manage_afterAdd(self, item, container):
        """AbstractElement has an afterAdd method"""
        zLOG.LOG(self.meta_type, zLOG.INFO, 'manage_afterAdd(%s, %s)' % (item.getId(), container.getId()))
        AbstractElement.manage_afterAdd(self, item, container)

# only register if MyMediaManager is installed
try:
    from Products.MyMediaManager.General import audioformats
    Globals.InitializeClass(PlayerElement)

    # Register as an element type with the Article class
    Article._elementTypes.append(PlayerElement)
except ImportError:
    pass