"""
    Utility functions.
"""
import zLOG
from Products.CMFDefault.utils import SimpleHTMLParser, parseHeadersBody, bodyfinder, html_headcheck
from TAL.HTMLParser import HTMLParser, HTMLParseError

class HTMLArticleParser(HTMLParser):
    """
    For now we just use it to check if there are any images to extract.
    """
    tags = {}
    taglevel = {}
    current = []
    tag_handlers = {}

    def add_tag_handler(self, tag, handler):
        self.tag_handlers[tag] = handler

    def handle_tag(self, tag):
        if self.tag_handlers.has_key(tag) and self.tags.has_key(tag):
            handler = self.tag_handlers[tag]
            data = self.tags[tag][self.current_tag_index()]
            apply(handler, (tagdata,))

    def current_tag(self):
        if len(self.current):
            return self.current[len(self.current)-1]
        else:
            return ''

    def current_tag_index(self):
        return self.taglevel[self.current_tag()]

    def open_tag(self, tag, attrs):
        zLOG.LOG('HTMLArticleParser', zLOG.INFO, 'open_tag - %s' % tag)
        self.current.append(tag)
        if not self.tags.has_key(tag):
            zLOG.LOG('HTMLArticleParser', zLOG.INFO, 'open_tag - adding %s to list' % tag)
            self.tags[tag] = []
        self.tags[tag].append(
                    {
                     'data':''
                    ,'attributes':attrs
                    }
                    )
        if not self.taglevel.has_key(tag):
            self.taglevel[tag] = -1

        self.taglevel[tag] = self.taglevel[tag] + 1

    def close_tag(self, tag):
        zLOG.LOG('HTMLArticleParser', zLOG.INFO, 'close_tag - %s' % tag)
        self.handle_tag(tag)
        self.current.pop()
        if not self.taglevel.has_key(tag):
            self.taglevel[tag] = 0

        self.taglevel[tag] = self.taglevel[tag] - 1

    def addto_tag(self, data):
        if self.current_tag() and data:
            zLOG.LOG('HTMLArticleParser', zLOG.INFO, 'addto_tag - add %s to tag %s' % (data, self.current_tag()))
            cdata = self.tags[self.current_tag()][self.current_tag_index()]['data']
            self.tags[self.current_tag()][self.current_tag_index()]['data'] = cdata + data

    def handle_startendtag(self, tag, attrs):
        self.open_tag(tag, attrs)
        self.close_tag(tag)

    def handle_starttag(self, tag, attrs):
            self.open_tag(tag, attrs)

    def handle_endtag(self, tag):
            self.close_tag(tag)

    def handle_charref(self, name):
        self.addto_tag("&#%s;" % name)

    def handle_entityref(self, name):
        self.addto_tag("&%s;" % name)

    def handle_data(self, data):
        self.addto_tag(data)


def guessFormat(text):
    """ Simple stab at guessing the inner format of the text """
    if html_headcheck(text): return 'html'
    else: return 'stx'

def handleText(text, format=None):
    """ Handles the raw text, returning headers, body, cooked, format """
    headers = {}
    if not format:
        format = guessFormat(text)
    if format == 'html':
        parser = SimpleHTMLParser()
        parser.feed(text)
        headers.update(parser.metatags)
        if parser.title:
            headers['Title'] = parser.title
        bodyfound = bodyfinder(text)
        if bodyfound:
            body = bodyfound
    else:
        headers, body = parseHeadersBody(text, headers)

    return headers, body, format

